/*
 *  (c) Copyright 1985 HEWLETT-PACKARD COMPANY
 *
 *  To anyone who acknowledges that this file is provided "AS IS"
 *  without any express or implied warranty:
 *      permission to use, copy, modify, and distribute this file
 *  for any purpose is hereby granted without fee, provided that
 *  the above copyright notice and this notice appears in all
 *  copies, and that the name of Hewlett-Packard Company not be
 *  used in advertising or publicity pertaining to distribution
 *  of the software without specific, written prior permission.
 *  Hewlett-Packard Company makes no representations about the
 *  suitability of this software for any purpose.
 */

#include "prefix.h"

retreg		.equ	r29
tmp		.equ	r1
#define 	rtn	bv,n  0(r31)

	.space $TEXT$
	.subspa $MILLICODE$
	.export $$divoI, millicode
	.align	4
	.proc
	.callinfo millicode
	.entry
$$divoI
	add,>=	0,arg0,retreg		; move dividend, if retreg < 0,
	sub	0,retreg,retreg		; make it positive
	subt,=	0,arg1,tmp		; check 0, clear carry, 
					;   negate the divisor
					;   trap if divisor = 0
	ds	0,tmp,0			; set V-bit to the comple-
					;   ment of the divisor sign
	or	0,0,tmp			; clear tmp
	add	retreg,retreg,retreg	; shift msb bit into carry
	ds,<<	tmp,arg1,tmp		; 1st divide step, if no carry
					;   out, msb of quotient = 0
	b	div_ovfl		; to test divide overflow
	addc	retreg,retreg,retreg	; shift retreg with/into carry
L$0001	ds	tmp,arg1,tmp		; 2nd divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 3rd divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 4th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 5th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 6th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 7th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 8th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 9th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 10th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 11th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 12th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 13th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 14th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 15th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 16th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 17th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 18th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 19th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 20th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 21st divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 22nd divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 23rd divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 24th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 25th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 26th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 27th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 28th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 29th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 30th divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 31st divide step
	addc	retreg,retreg,retreg	; shift retreg with/into carry
	ds	tmp,arg1,tmp		; 32nd divide step,
	addc	retreg,retreg,retreg	; shift last retreg bit into retreg
	addb,>=,n tmp,0,finish		; branch if pos. tmp
	add,<	arg1,0,0		; if arg1 > 0, add arg1
	add,tr	tmp,arg1,tmp		;   for correcting remainder tmp
	sub	tmp,arg1,tmp		; else add absolute value arg1
finish	add,>=	arg0,0,0		; set sign of remainder
	sub	0,tmp,tmp		;   to sign of dividend
	xor,>=	arg0,arg1,0		; get correct sign of quotient
	sub	0,retreg,retreg		;   based on operand signs
	.exit
	rtn
	nop

div_ovfl
	b	L$0001			; return if no overflow trap
	addo	arg0,arg1,0		; abs(quotient) > 2**31, ovfl.
					;   only if dvd=0x80000000
					;   and divisor = -1

	.procend
	.end
