/*
 * Mach Operating System
 * Copyright (c) 1989,1988,1987 Carnegie Mellon University
 * Copyright (c) 1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).
 * All Rights Reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon
 * the rights to redistribute these changes.
 */

#ifndef	_MACHINE_SYSCALL_SW_
#define	_MACHINE_SYSCALL_SW_	1

	.space	$TEXT$
	.subspa	$CODE$,QUAD=0,ALIGN=8,ACCESS=44,CODE_ONLY

#define kernel_trap(trap_name,trap_number,number_args)\
trap_name:						!\
		.proc					!\
		.callinfo				!\
		.entry					!\
		ldil	L%0xC0000000,%r1		!\
		ble	4(%sr7,%r1)			!\
		ldi	trap_number,%r22		!\
		bv,n	0(%r2)				!\
		.exit					!\
		.procend				!\
		.export	trap_name

#endif	_MACHINE_SYSCALL_SW_
